// 在main.js上通过import引入Vue库和自己写的Vue组件库
import Vue from "vue";
import "vant/lib/index.css";
import { Tab, Tabs } from 'vant';
import { DatetimePicker } from 'vant';
import { Popup } from 'vant';

Vue.use(Tab);
Vue.use(Tabs);
Vue.use(DatetimePicker);
Vue.use(Popup);

import DataStatistics from "./components/dataStatistics.vue";
import eventBus from "../../../../../../util/eventBus";
(function (KDApi) {
  function MyComponent(model) {
    this._setModel(model);
  }

  MyComponent.prototype = {
    _setModel: function (model) {
      this.model = model;
    },
    init: function (props) {
      console.log("===init===", this.model, props);
      setHtml(this.model, props);
    },
    update: function (props) {
      console.log("===update===", this.model, props);
      eventBus.pub(this.model, "update", props);
    },
    destoryed: function () {
      console.log("===destoryed===", this.model);
      eventBus.unsub(this.updateSub);
    },
  };

  const setHtml = (model, props) => {
    const { invoke } = model;

    KDApi.loadFile("./css/index.css", model, () => {
      new Vue({
        el: model.dom,
        template: `<DataStatistics />`,
        components: {
          DataStatistics,
        },
        data: function () {
          return {
            
          };
        },
        mounted() {
          let self = this;
          this.updateSub = eventBus.sub(model, "update", (data) => {
            self.initData(data);
          });
          self.initData(props);
        },
        methods: {
          //后端传递的数据
          initData(props) {
            if (props && props.data) {
              
            } else {
              
            }
          },
          //发送数据给后端
          invoke: function (eventName, args) {
            invoke(eventName, args);
          },
          
        },
      });
    });
  };

  // 注册自定义组件
  KDApi.register("dataStatisticsKy", MyComponent);
})(window.KDApi);
